//-*-c++-*-
/***************************************************************************
 *   Copyright (C) 2003 by Fred Schaettgen                                 *
 *   kdebluetooth@schaettgen.de                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef ATCOMMANDER_H
#define ATCOMMANDER_H

#include <qobject.h>
#include <qguardedptr.h>

namespace KBluetooth {
    class RfcommSocket;
}

/**
@author Fred Schaettgen
*/
class AtCommander : public QObject
{
Q_OBJECT
public:
    AtCommander(QObject *owner, const char* name,
        KBluetooth::RfcommSocket *socket);
    ~AtCommander();
    bool sendAtCommand(QString s, double timeout = 3.0,
        bool waitForResult = true);

signals:
    void unsolicitedResult(QString s);
    void lineReceived(QString s);
    void lineSent(QString s);
    void timeout();

private:
    QGuardedPtr<KBluetooth::RfcommSocket> socket;
    QString recvBuf;
    bool waitingForResult;
    bool lastResultOK;

private slots:
    void slotSocketReadyRead();
};

#endif
