//-*-c++-*-
/***************************************************************************
 *   Copyright (C) 2003 by Fred Schaettgen                                 *
 *   kdebluetooth@schaettgen.de                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef VORBISENCODER_H
#define VORBISENCODER_H

#include <qobject.h>
#include <qmap.h>
#include <qfile.h>
#include "vorbis/vorbisenc.h"

/**
@author Fred Schaettgen
*/
class VorbisEncoder : public QObject
{
Q_OBJECT
private:
    ogg_stream_state os; /* take physical pages, weld into a logical
                            stream of packets */
    ogg_page         og; /* one Ogg bitstream page.  Vorbis packets are inside */
    ogg_packet       op; /* one raw packet of data for decode */

    vorbis_info      vi; /* struct that stores all the static vorbis bitstream
                            settings */
    vorbis_comment   vc; /* struct that stores all the user comments */

    vorbis_dsp_state vd; /* central working state for the packet->PCM decoder */
    vorbis_block     vb; /* local working space for packet->PCM decode */

    QFile outfile;
    bool bInit;
    QMap<QString, QString> tagMap;

public:
    VorbisEncoder(QObject* parent, QString filename);
    void setTag(QString key, QString value);
    QString tag(QString key);
    bool init();
    QString filename();
    ~VorbisEncoder();
public slots:
    // datalen in Q_INT16s!
    void writeBlock(Q_INT16* dataLeft, Q_INT16* dataRight, int datalen);
};

#endif
