/***************************************************************************
                          irmcsynckonnector.h  -  description
                             -------------------
    begin                : Sat Feb 14 2003
    copyright            : (C) 2003 by Simone Gotti
	
	from the threaded konnector of Mathias Froehlich <Mathias.Froehlich@web.de>
	
    email                : simone.gotti@email.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IRMCSYNCKONNECTOR_H
#define IRMCSYNCKONNECTOR_H

#include <qiconset.h>
#include <qptrlist.h>

#include <konnector.h>

#include "clientmanager.h"
#include "irmcsyncconfig.h"

namespace KSync
{

	/**
	 * This plugin gets loaded by the KonnectorManager
	 * this is the key to the KonnectorWorld
	 * we need to implement the interface to fully support it...
	 */
	class ThreadedPlugin
				: public KSync::Konnector
	{
		Q_OBJECT
	public:
		/**
		 * @param parent the Parent Object
		 * @param name the name
		 * @param strlist a QStringList which is not used but necessary for KGenericFactory
		 */
		ThreadedPlugin( const KConfig *config );
		~ThreadedPlugin();
		
		
		IrMCSyncConfig *mConfigWidget;

		void writeConfig( KConfig *cfg );
		
		// They were removed on 2004-10-08, let's what happens now...
		
		// /** return our capabilities() */
		// KSync::Kapabilities capabilities();

		// /**
		//  * the user configured this konnector
		//  * apply his preferecnes
		//  */
		// void setCapabilities( const KSync::Kapabilities& );

		SynceeList syncees();

		bool readSyncees();
		bool writeSyncees();

		bool connectDevice();
		bool disconnectDevice();

		/** the state and some informations */
		KSync::KonnectorInfo info() const;

		/** download a resource/url/foobar */
		void download( const QString& );


		void setDeviceBtAddress( const QString &deviceBtAddress ) { mDeviceBtAddress = deviceBtAddress; }
		QString deviceBtAddress() const { return mDeviceBtAddress; }
		
		void setSyncCalendar( const bool &syncCalendar ) { mSyncCalendar = syncCalendar; }
		bool syncCalendar() const { return mSyncCalendar; };
		void setSyncAddressBook( const bool &syncAddressBook ) { mSyncAddressBook = syncAddressBook; }
		bool syncAddressBook()  const { return mSyncAddressBook; };

	protected:
		/*     QString metaId() const; */
		/*     QIconSet iconSet() const; */
		/*     QString iconName() const; */

	private slots:
		void slotFinished();
		// They were removed on 2004-10-08, let's what happens now...
		
		// void slotError( const KSync::Error& );
		// void slotProgress( const KSync::Progress& );
		void slotSynceeReaded( KSync::Syncee* );
		void slotSynceeWrited();

	private:

		QString mDeviceBtAddress;
		bool mSyncCalendar;
		bool mSyncAddressBook;

		int threadsNumber;
		int readedSynceesNumber;
		
		/* The Obex Client */
		Client *obex;
		/* sync data */
		SynceeList mSyncees;

		ClientManager* mCalendarClientManager;
		ClientManager* mAddressBookClientManager;
	};
} 

#endif
