/***************************************************************************
                          devinfo.cpp  -  description
                             -------------------
    begin                : Sat Ott 28 2003
    copyright            : (C) 2003 by Simone Gotti
    email                : motaboy@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "devinfo.h"

using namespace KBluetooth;
using namespace SDP;
using namespace std;

DevInfo::DevInfo()
{
    m_discovered = false;
}

DevInfo::~DevInfo() {}

DevInfo::ServiceInfoVector& DevInfo::services()
{
	return m_services;
}

bool DevInfo::haveServiceClassID(QString uuid)
{
    ServiceInfoVector::iterator servIt;
    for(servIt = m_services.begin(); servIt != m_services.end(); ++servIt) {
        KBluetooth::SDP::UUIDVec::iterator uuidIt;
        //for(uuidIt = servIt->classIdList().begin(); uuidIt != servIt->classIdList().end(); ++uuidIt) {
          //  if((*uuidIt) == SDP::uuid_t(uuid))
		  	if(servIt->haveClassID(uuid))
                return true;
       // }
    }
    return false;
}

QString DevInfo::name()
{
    return devName;
}

KBluetooth::DeviceAddress DevInfo::address()
{
    return devAddress;
}

bool DevInfo::discovered()
{
	return m_discovered;
}

std::vector<uint> DevInfo::rfcommChannels(QString uuid)
{
    std::vector<uint> rfcommList;

    ServiceInfoVector::iterator servIt;
    for(servIt = m_services.begin(); servIt != m_services.end(); ++servIt) {
        KBluetooth::SDP::UUIDVec::iterator uuidIt;
        //for(uuidIt = servIt->classIdList().begin(); uuidIt != servIt->classIdList().end(); ++uuidIt) {
          //  if((*uuidIt) == SDP::uuid_t(uuid))
		  if(servIt->haveClassID(uuid))
                rfcommList.push_back(servIt->rfcommChannel());
        //}
    }
    return rfcommList;
}

void DevInfo::addService(ServiceInfo service)
{
	m_services.push_back(service);
}

void DevInfo::clearServices()
{
	m_services.clear();
}

void DevInfo::setName(QString name)
{
	devName = name;
}

void DevInfo::setAddress(KBluetooth::DeviceAddress address)
{
	devAddress = address;
}

void DevInfo::setDiscovered(bool discovered)
{
	m_discovered = discovered;
}
