/***************************************************************************
                          serviceinfo.cpp  -  description
                             -------------------
    begin                : Sat Ott 28 2003
    copyright            : (C) 2003 by Simone Gotti
    email                : motaboy@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "serviceinfo.h"


using namespace KBluetooth;
using namespace SDP;
using namespace std;

ServiceInfo::ServiceInfo()
{
    m_status = Down;
}

ServiceInfo::~ServiceInfo() {}

bool ServiceInfo::haveClassID(QString uuid)
{
    KBluetooth::SDP::UUIDVec::iterator uuidIt;
    for(uuidIt = m_classIdList.begin(); uuidIt != m_classIdList.end(); ++uuidIt) {
        if((*uuidIt) == SDP::uuid_t(uuid))
            return true;
    }
    return false;
}

KBluetooth::SDP::UUIDVec& ServiceInfo::classIdList()
{
    return m_classIdList;
}

uint ServiceInfo::rfcommChannel()
{
    return m_rfcommChannel;
}

ServiceInfo::ServiceStatus ServiceInfo::status()
{
    return m_status;
}

void ServiceInfo::setStatus(ServiceInfo::ServiceStatus status)
{
    m_status = status;
}

void ServiceInfo::addUUID(KBluetooth::SDP::uuid_t uuid)
{
    m_classIdList.push_back(uuid);
}

void ServiceInfo::setRfcommChannel(uint channel)
{
    m_rfcommChannel = channel;
}

void ServiceInfo::setClassIdList(KBluetooth::SDP::UUIDVec list)
{
	KBluetooth::SDP::UUIDVec::iterator it;
	for(it = list.begin(); it != list.end(); ++it)
    	addUUID(*it);
}


