/***************************************************************************
                          serviceinfo.h  -  description
                             -------------------
    begin                : Sat Ott 28 2003
    copyright            : (C) 2003 by Simone Gotti
    email                : motaboy@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _SERVICEINFO_H_
#define _SERVICEINFO_H_


#include <qstringlist.h>
#include <vector>
#include <qguardedptr.h>
#include <libkbluetooth/deviceaddress.h>
#include <libkbluetooth/sdpdevice.h>

class ServiceInfo
{

public:
	enum ServiceStatus { Cached,
                         Down,
                         DeviceDiscovered,
                         ServiceDiscovered};

    ServiceInfo();
    ~ServiceInfo();

    bool haveClassID(QString uuid);
    uint rfcommChannel();
	ServiceStatus status();
	KBluetooth::SDP::UUIDVec& classIdList();

	void setStatus(ServiceStatus);
	void setClassIdList(KBluetooth::SDP::UUIDVec list);
	void setRfcommChannel(uint);
	void addUUID(KBluetooth::SDP::uuid_t);


protected:

    ServiceStatus m_status;
    KBluetooth::SDP::UUIDVec m_classIdList;
    uint m_rfcommChannel;

};

#endif // _SERVICEINFO_H_
