/***************************************************************************
                          ultrainquiry.h  -  description
                             -------------------
    begin                : Sat Ott 18 2003
    copyright            : (C) 2003 by Simone Gotti
    email                : motaboy@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _ULTRAINQUIRY_H_
#define _ULTRAINQUIRY_H_


#include "devinfo.h"
#include "serviceinfo.h"

#include <qstring.h>
#include <vector>
#include <qguardedptr.h>
#include <libkbluetooth/deviceaddress.h>
#include <libkbluetooth/sdpdevice.h>


namespace KBluetooth
{
    class DeviceAddress;
    class Inquiry;
    class RfcommSocket;

    namespace SDP
    {
        class Device;
        class uuid_t;
    }
}

class KAction;
class DevInfo;

/**
@author Simone Gotti
*/
class UltraInquiry : public QObject
{
    Q_OBJECT

public:
    UltraInquiry(QObject *parent);
    ~UltraInquiry();

	void inquiry();
    std::vector<DevInfo> getDevices(QString classId = QString::null);

signals:
    void newDevice(void);
    void finished();

private:
    QGuardedPtr< KBluetooth::Inquiry > normalInquiry;
    QString lastUsedAddress;

    typedef std::vector<DevInfo> DevInfoVector;
    DevInfoVector devInfos;

    void updateDeviceInfos();
    void removeOldDevices();

    bool alreadyInserted(const KBluetooth::DeviceAddress& addr);
    DevInfo& getDeviceInfo(const KBluetooth::DeviceAddress& addr);

	void readConfig();
    void writeConfig();

private slots:
    void slotInquiryDeviceFound(const KBluetooth::DeviceAddress& addr);
    void slotInquiryFinnished();

};

#endif // _ULTRAINQUIRY_H_
